Bug 324114 - 2 deadlocks in Filter Dialog: closing Krita | opening second instance of the Filter Dialog
Summary: 2 deadlocks in Filter Dialog: closing Krita | opening second instance of the ...
Status: RESOLVED FIXED
Alias: None
Product: krita
Classification: Unclassified
Component: Filters (show other bugs)
Version: git master (please specify the git hash!)
Platform: unspecified Linux
: NOR major
Target Milestone: ---
Assignee: Dmitry Kazakov
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-08-27 11:54 UTC by Dmitry Kazakov
Modified: 2013-12-31 11:53 UTC (History)
1 user (show)

See Also:
Latest Commit:
Version Fixed In:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Dmitry Kazakov 2013-08-27 11:54:16 UTC
1) Closing Krita while Filter Dialog is active hangs Krita
2) Opening the second Filter Dialog (yes, this is currently possible in Krita ;) ) hangs Krita

Both deadlocks happen because the Filter Dialog (or the first instance of it) cannot finish the stroke, so the GUI thread will wait in image->waitForDone() forever.
Comment 1 Halla Rempt 2013-08-27 18:46:16 UTC
Ack. I think this is a pretty grave bug!
Comment 2 Halla Rempt 2013-12-31 11:53:16 UTC
Git commit 1f9d742bc54b1f7faefa761381daad27d3abd94d by Boudewijn Rempt.
Committed on 31/12/2013 at 11:23.
Pushed by rempt into branch 'calligra/2.8'.

Make it impossible to open a second filter dialog

M  +11   -11   krita/ui/dialogs/kis_dlg_filter.cpp
M  +4    -4    krita/ui/dialogs/kis_dlg_filter.h
M  +17   -6    krita/ui/kis_filter_manager.cc

http://commits.kde.org/calligra/1f9d742bc54b1f7faefa761381daad27d3abd94d
Comment 3 Halla Rempt 2013-12-31 11:53:17 UTC
Git commit 98ba34a7b0f1a5ea4af15daf69281a2a7e44d039 by Boudewijn Rempt.
Committed on 31/12/2013 at 11:52.
Pushed by rempt into branch 'calligra/2.8'.

Cancel a running stroke in the filter manager when closing the view

This needs to be done before we enter the destructor of KisImage.

M  +4    -0    krita/ui/kis_view2.cpp

http://commits.kde.org/calligra/98ba34a7b0f1a5ea4af15daf69281a2a7e44d039
Comment 4 Halla Rempt 2013-12-31 11:53:38 UTC
Git commit a81f7773a900516b20af43d2fc777b7f38e3f7f8 by Boudewijn Rempt.
Committed on 31/12/2013 at 11:23.
Pushed by rempt into branch 'master'.

Make it impossible to open a second filter dialog

M  +11   -11   krita/ui/dialogs/kis_dlg_filter.cpp
M  +4    -4    krita/ui/dialogs/kis_dlg_filter.h
M  +17   -6    krita/ui/kis_filter_manager.cc

http://commits.kde.org/calligra/a81f7773a900516b20af43d2fc777b7f38e3f7f8
Comment 5 Halla Rempt 2013-12-31 11:53:39 UTC
Git commit 002b58a0ad55d32ca14f971cd5bb19ec7f10f7e8 by Boudewijn Rempt.
Committed on 31/12/2013 at 11:52.
Pushed by rempt into branch 'master'.

Cancel a running stroke in the filter manager when closing the view

This needs to be done before we enter the destructor of KisImage.

M  +4    -0    krita/ui/kis_view2.cpp

http://commits.kde.org/calligra/002b58a0ad55d32ca14f971cd5bb19ec7f10f7e8